"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MaterialTools_1 = require("./MaterialTools");
var Logger_1 = require("./common/Logger");
var options_1 = require("./cli/options");
var commands_1 = require("./cli/commands");
var yargs = require('yargs');
options_1.registerOptions(yargs)
    .strict()
    .help();
// Sub-commands have to be registered after all the global arguments.
commands_1.registerCommands(yargs);
var options = yargs.argv;
new MaterialTools_1.MaterialTools(options.config || options)
    .build(options._[0])
    .then(function (data) { return Logger_1.Logger.log("Successfully built " + data.dependencies._flat.join(', ') + "."); })
    .catch(function (error) { return Logger_1.Logger.error(error.stack || error); });
//# sourceMappingURL=MaterialCLI.js.map