"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
var IS_VERBOSE = process.argv.indexOf('--verbose') !== -1;
var IS_SILENT = process.argv.indexOf('--silent') !== -1;
var Logger = /** @class */ (function () {
    function Logger() {
    }
    /** Logs a regular console message. */
    Logger.log = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        if (!IS_SILENT) {
            console.log.apply(console, __spreadArrays([this._currentTime()], messages));
        }
    };
    /** Logs a regular message, only if verbose mode is enabled. */
    Logger.info = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        if (IS_VERBOSE) {
            console.info.apply(console, __spreadArrays([this._currentTime()], messages));
        }
    };
    /** Logs a warning message. */
    Logger.warn = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        if (!IS_SILENT) {
            console.warn.apply(console, __spreadArrays([this._currentTime()], messages));
        }
    };
    /** Logs an error message. */
    Logger.error = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        if (!IS_SILENT) {
            console.error.apply(console, __spreadArrays([this._currentTime()], messages));
        }
    };
    Logger._currentTime = function () {
        var date = new Date();
        var timeDigits = [date.getHours(), date.getMinutes(), date.getSeconds()]
            .map(function (value) { return value < 10 ? '0' + value : value; })
            .join(':');
        return "[" + timeDigits + "]:";
    };
    return Logger;
}());
exports.Logger = Logger;
//# sourceMappingURL=Logger.js.map