"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrowserWindow = exports.BrowserElement = exports.BrowserTextNode = exports.BrowserNode = exports.BrowserDocument = void 0;
/** Basic noop function to be used for the several mock objects */
var noop = function () { };
/** Simple Browser Document Mock */
var BrowserDocument = /** @class */ (function () {
    function BrowserDocument() {
        this.head = new BrowserElement();
        this.addEventListener = noop;
        this.contains = noop;
        this.querySelector = noop;
        this.createElement = function () { return new BrowserElement(); };
        this.createTextNode = function (data) {
            var node = new BrowserTextNode();
            node.data = data;
            return node;
        };
    }
    return BrowserDocument;
}());
exports.BrowserDocument = BrowserDocument;
/** Minimal Browser Node Object */
var BrowserNode = /** @class */ (function () {
    function BrowserNode() {
        var _this = this;
        this.pathname = '';
        this.children = [];
        this.appendChild = function (child) {
            _this.children.push(child);
        };
        this.insertBefore = this.appendChild;
    }
    return BrowserNode;
}());
exports.BrowserNode = BrowserNode;
/** Browser Text Node Object */
var BrowserTextNode = /** @class */ (function (_super) {
    __extends(BrowserTextNode, _super);
    function BrowserTextNode() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.data = '';
        return _this;
    }
    return BrowserTextNode;
}(BrowserNode));
exports.BrowserTextNode = BrowserTextNode;
/** Minimal Browser HTML Element */
var BrowserElement = /** @class */ (function (_super) {
    __extends(BrowserElement, _super);
    function BrowserElement() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.setAttribute = noop;
        _this.firstElementChild = {};
        return _this;
    }
    return BrowserElement;
}(BrowserNode));
exports.BrowserElement = BrowserElement;
/** Window Variable / Globals of the Browser */
var BrowserWindow = /** @class */ (function () {
    function BrowserWindow() {
        this.addEventListener = noop;
        this.document = new BrowserDocument();
        this.Node = BrowserNode;
        this.location = {};
        this.console = console;
        // Apply the Browser Window to the browser window / globals, because the window will be our
        // root, which will be sometimes called within the `window` property.
        this.window = this;
    }
    return BrowserWindow;
}());
exports.BrowserWindow = BrowserWindow;
//# sourceMappingURL=MockBrowser.js.map